define(["require", "blue/as/serializable", "blue/is", "blue/object/extend", "blue/util", "blue/deferred", "blue/log"], (function(e) {
    "use strict";
    var t = e("blue/as/serializable"),
        n = e("blue/is"),
        i = e("blue/object/extend"),
        o = e("blue/util").object.deepClone,
        s = e("blue/deferred"),
        r = e("blue/log")("[blue:view]"),
        a = {
            append: !1,
            react: !1
        },
        c = 0;

    function p(e, t, r, c, p, m) {
        var v = n.array(c) ? c[0] : c.component,
            l = n.array(c) ? c[1] : c.view,
            h = n.array(c) ? c[2] || {} : c.options,
            g = m ? o(m) : e.viewResolverOptions || {};
        this.hasComponent = !v, this.hasView = !1, this.view = void 0, this.component = void 0, this.viewName = void 0, this.options = i({}, a, h || {}), this.resolving = new s, this.resolved = this.resolving.promise, v && this.setComponent(e, v, l), this.viewEngine = t, n.string(l) && "/" !== l[0] && v && v.context ? v.context.page && v.context.page.viewResolverOptions && (g = o(v.context.page.viewResolverOptions)) : n.string(l) && "/" === l[0] && (l = l.substr(1), g = {}), l && this.setView(e, r, l, p, g)
    }
    return p.prototype.resolve = function() {
        var e;
        if (this.isReady()) {
            if (this.component && this.view.viewName && !this.component._("viewName") && this.component._("viewName", this.view.viewName), !this.viewInternals.bridge) {
                var t = this.component && this.component.key ? this.component.key : "EMPTY";
                this.viewInternals.createBridge({
                    name: t,
                    bindings: {},
                    triggers: {}
                })
            }
            this.component && (e = this.component.spec || {}, this.viewInternals.bridge.addComponentSpecData(Object.keys(e.data || {}).reduce((function(e, t) {
                return e[t] = 1, e
            }), {})), this.viewInternals.bridge.addComponentSpecSettings(this.component.getSettingsValues()), this.viewInternals.bridge.addComponentSpecActions(this.component.getActionNames()), this.view._componentStack = this.component.context.getStack()), this.component && this.component.context && (this.view.htmlAttrs["data-component-name"] = this.component.context.parent.getStack() + "|" + (this.component.key || this.component.context.name) + "|" + this.component.spec.name + "|" + this.component._("guid")), this.options.viewInternals = this.viewInternals, this.resolving.resolve([this.component, this.view, this.options])
        }
    }, p.prototype.reject = function(e, t) {
        t.msg = t.message, r.error("[" + e.getStack() + "]", "CAV failed to resolve:", t), e.page.emit("page:error", {
            code: "blue:cav:error:cavResolutionFailed",
            description: "CAV could not be resolved:" + t
        }), this.resolving.reject(t)
    }, p.prototype.setComponent = function(e, t, i) {
        var o = this;
        t.oldComponent ? (t.oldComponent.then((function() {
            o.component = t, o.component._("viewName", n.string(i) ? i : ""), o.hasComponent = !0, o.resolve()
        })).catch((function(s) {
            s.msg = s.message, r.warn("[" + e.getStack() + "]", "Old Component instance " + t.key + " failed to destroy cleanly", s), o.component = t, o.component._("viewName", n.string(i) ? i : ""), o.hasComponent = !0, r.error("[" + e.getStack() + "]", "CAV component " + t.key + " failed to remove old component with same name:", s), e.page.emit("page:error", {
                code: "blue:cav:error:componentConstructionFailed",
                description: "CAV component " + t.key + " failed to remove old component with same name:" + s
            }), o.reject(e, s)
        })), delete t.oldComponent) : (o.component = t, o.component._("viewName", n.string(i) ? i : ""), o.hasComponent = !0, o.resolve())
    }, p.prototype.setView = function(e, t, i, o, s) {
        var a, p, m, v = this,
            l = s.prefix || "",
            h = s.suffix || "";
        s = s || {}, n.string(i) ? (this.viewName = i, t[a = o + "/" + i] ? (p = t[a], s = {}, m = e.getViewRegistry(v.viewEngine)) : (p = l + i + h, m = e.getViewRegistry(v.viewEngine)), a = a + "/" + c, m.then((function(t) {
            n.string(p) ? t.registerView(a, e.viewResolver.createId(p, s), !0) : t.registerView(a, p, !0)
        }))) : (this.viewName = i.name || i.viewName || "anonymous", a = l + this.viewName + h, (m = e.getViewRegistry(v.viewEngine)).then((function(e) {
            e.registerView(a, i, !0)
        }))), n.object(this.options) && n.defined(i.targetSelector) && !n.defined(this.options.target) && (this.options.target = i.targetSelector), m.then((function(t) {
            t.getView(a).then((function(t) {
                t && n.function(t.replaceIn) && n.function(t.appendTo) ? (v.view = t, v.viewInternals = t.link(), v.viewName && !v.view.viewName && (v.view.viewName = v.viewName)) : r.warn("[" + e.getStack() + "]", "This is not a view!", t), v.hasView = !0, v.resolve()
            }), (function(t) {
                t.msg = t.message, r.error("[" + e.getStack() + "]", "CAV view " + v.viewName + " failed to resolve:", t), e.page.emit("page:error", {
                    code: "blue:cav:error:viewResolutionFailed",
                    description: "CAV view " + v.viewName + " failed to resolve:" + t.name + ":" + t.message
                }), v.reject(e, t)
            }))
        })), c++
    }, p.prototype.isReady = function() {
        return this.hasComponent && this.hasView
    }, t.call(p.prototype, (function() {
        return "ComponentAndView"
    })), p
}));